package src;

public class AvecCarte extends Main {


	private Main suite;

	private Carte premiere;

	public Main getSuite() {
		return suite;
	}

	public Carte getPremiere() {
		return premiere;
	}

	/**
	 * Permet d'ajouter une carte dans une sequence.
	 * TODO on pourrait interdire les doublons ici
	 * @param s
	 * @param c
	 */
	public AvecCarte(Main s, Carte c) {
		this.premiere = c;
		this.suite = s;
	}

	public int taille() {
		return 1 + this.suite.taille();
	}


	public String toString() {
		return this.premiere.toString() + " ; " + this.suite.toString();
	}

	/**
	 * Insertion des cartes.
	 * Avec elimination des doublons
	 */
	public AvecCarte inserer(Carte arg2) {
		int cmp = this.premiere.getValeur().compareTo(arg2.getValeur());
		if (cmp > 0) {
			return new AvecCarte(this, arg2);
		} else if (cmp < 0) {
			return new AvecCarte(this.suite.inserer(arg2), this.premiere);
		} else {
			// if equals do nothing
			return this;
		}

	}

	/**
	 * Trie en odre croissant.
	 */
	public Main tri() {
		return this.suite.tri().inserer(this.premiere);
	}

	public boolean estTriee() {
		// should test the length here !
		if (this.taille() == 1) {
			return true;
		} else {
			// hint: une sol avec retract
			return (this.premiere.getValeur().compareTo(((AvecCarte) this.suite).getPremiere().getValeur())) <= 0
					&& this.getSuite().estTriee();
		}
	}



}