package tests;

import src.AvecCarte;
import src.Carte;
import src.Couleur;
import src.Main;
import src.SansCarte;
import src.Valeur;


/**
 * Test pour les mains.
 * 18/08/2010
 * @author jroyer
 */
public class Test {

	/**
	 * principale.
	 * @param arg meuh!!!!
	 */
	public static void main(final String[] arg) {
		// valeurs
		Valeur sept, huit, neuf, dix, valet, dame, roi, as;
		sept = new Valeur("sept", 7);
		neuf = new Valeur("neuf", 9);
		as = new Valeur("as", 14);
		roi = new Valeur("roi", 13);

		// couleurs
		Couleur carreau, pique, trefle, coeur;
		pique = new Couleur("pique");
		coeur = new Couleur("coeur");
		trefle = new Couleur("trefle");
		// creation carte
		Carte p7 = new Carte(sept, pique);
		System.out.println(" La carte est " + p7);

		Carte c9 = new Carte(neuf, coeur);
		System.out.println(" La carte est " + c9);
		System.out.println(" couleur ? " + p7.getCouleur().equals(c9.getCouleur()));
		System.out.println(" ordre ? " + p7.getValeur().compareTo(c9.getValeur()));

		Carte tas = new Carte(as, trefle);
		Carte rc = new Carte(roi, coeur);

		//
		SansCarte sc = new SansCarte();
		AvecCarte m1, m2;

		//
		m1 = new AvecCarte(new AvecCarte(sc, p7), c9);
		m2 = new AvecCarte(new AvecCarte(m1, p7), tas);
		System.out.println(" main : " + m2);
		System.out.println(" tri : " + m2.tri());

		Main m3 = m2.tri();

		// test propriete 1
		System.out.println(" (m3.estTriee() && m3.inserer(rc).estTriee()) : " + (m3.estTriee() && m3.inserer(rc).estTriee()));

		// test propriete 2
		System.out.println(" m2.tri().estTriee() : " + m2.tri().estTriee());

		// test duplication
		System.out.println("  m3.inserer(p7) : " + m3.inserer(p7));
		System.out.println("  m3.inserer(c9) : " + m3.inserer(c9));
		System.out.println("  m3.inserer(tas) : " + m3.inserer(tas));
		System.out.println("  m3.inserer(rc).inserer(tas) : " + m3.inserer(rc).inserer(tas));

	}
}
